#include <stdio.h>
#include <iostream>
#include <sstream>
#include <vector>

#include "ca_opflat_options.h"


using namespace std;

namespace ca_options{

double thresholdval = 0;        
string prd_path;
string oprofile_sample_path;
string flat_file_path;
string opdata_plugin_version;
string output_plugin;
} // end of options namespace

namespace {
string threshold;

popt::option options_array[] = {
    popt::option(threshold, "threshold", 't',
	    "The minimun percentage", "percentage"),
    popt::option(ca_options::prd_path, "prdpath", 'p',
	    "The absolute path of prd file", "path"),
    popt::option(ca_options::oprofile_sample_path, "oppath", 'o',
	    "The absolute path of the folder containing oprofile samples", "path"),
    popt::option(ca_options::flat_file_path, "flatpath", 'f',
	    "The path of the flat file", "path"),
    popt::option(ca_options::opdata_plugin_version, "opdata-plugin", 'l',
        "The version of the oprofile data plugin to use.  Curently "
        "only supports 072", "version"),
    popt::option(ca_options::output_plugin, "output-plugin", 'u',
        "The version of the CodeAnalyst output plugin to use.  Curently "
        "supports flat and tbp.  Defaults to tbp", "output_type"),

};

} // end of anon namespace

/**
 * handle_threshold - Converts string threshold into a value of double  
 * @param threshold  The minimum number of the percentage to be displayed
 */
double handle_threshold(string threshold)
{
	double value = 0.0;

	if (threshold.length()) {
		istringstream ss(threshold);
		if (!(ss >> value)) {
			cerr << "illegal threshold value: " << threshold
			     << " allowed range: [0-100]" << endl;
			exit(EXIT_FAILURE);
		}

		if (value < 0.0 || value > 100.0) {
			cerr << "illegal threshold value: " << threshold
			     << " allowed range: [0-100]" << endl;
			exit(EXIT_FAILURE);
		}
	}

	cout << "threshold is " << value << endl;;

	return value;
}

void get_options(int argc, char const * argv[])
{
	vector<string> non_options;
	popt::parse_options(argc, argv, non_options);

	if (!threshold.empty())
		ca_options::thresholdval = ::handle_threshold(threshold);

    if (ca_options::oprofile_sample_path.empty())
        ca_options::oprofile_sample_path = "/var/lib/ca_oprofile/samples/current/";

    if (ca_options::prd_path.empty())
        ca_options::prd_path= "/var/lib/ca_oprofile/anonymous.prd";

    if (ca_options::opdata_plugin_version.empty())
        ca_options::opdata_plugin_version = "072";

    if (ca_options::opdata_plugin_version.empty())
        ca_options::opdata_plugin_version = "flat";
}


