/*
// CodeAnalyst for Open Source
// Copyright 2002 . 2005 Advanced Micro Devices, Inc.
// You may redistribute this program and/or modify this program under the terms
// of the GNU General Public License as published by the Free Software 
// Foundation; either version 2 of the License, or (at your option) any later 
// version.
//
// This program is distributed WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  See the 
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA 02111-1307 USA.
*/


#ifndef _PRD_READER_H_
#define _PRD_READER_H_

#include <string>
#include <iostream>
#include <fstream>

#include "op_types.h"
#include "libprofile_ctrl.h"

using namespace std;

class CPRDReader
{
public:
	CPRDReader();
	~CPRDReader();

	bool readPRDFile();

	bool openPRDFile(string fileName);

	bool readPRDHeader(prd_header & header);

    prd_record * readPRDFileBlock(unsigned int n);

    void closePRDFile();

    bool readNextRecord(prd_record * pRecord);
	
private:
	string m_PRDFileName;
	filebuf m_FileBuf;
	istream * m_IStream;
    unsigned int m_nRecords;
};

#endif
