#!/bin/bash

#
# CodeAnalyst for Open Source
# Copyright 2002 . 2006 Advanced Micro Devices, Inc.
# You may redistribute this program and/or modify this program under the terms
# of the GNU General Public License as published by the Free Software 
# Foundation; either version 2 of the License, or (at your option) any later 
# version.
#
# This program is distributed WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED 
# WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  See the 
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA 02111-1307 USA.

PWD=`dirname $0`
OPROFILED=$1/oprofiled
SUDO=`which sudo`
OPROFILED_CMD=/tmp/oprofiled_cmd

shift

enable_oprofile_monitor()
{
	PIDOF=`which pidof`

	OPROFILED_MONITOR="xterm -fg white -bg darkred \
			-T Oprofile_Daemon_Monitor \
			-e watch -n1 $PWD/oprofiled_monitor.sh"
	OPROFILE_DRV_MONITOR="xterm -fg white -bg darkred \
			-T Oprofile_Driver_Monitor \
			-e watch -n1 $PWD/oprofile_drv_monitor.sh"

	$PIDOF watch > /dev/null
	if test "$?" != "0" ; then
		$OPROFILED_MONITOR &
		$OPROFILE_DRV_MONITOR &
		
		#OPROFILED_LOG=/var/lib/oprofile/samples/oprofiled.log
		#xterm -fg white -bg darkred -T Oprofile_Log_Monitor -e watch -n1 "tail $OPROFILED_LOG 2> /dev/null" &
	fi
}


#############################################################################
# Default Mode: 
$SUDO $OPROFILED $@

#############################################################################
# (ROOT only) Uncomment to enable Oprofile Monitoring 
#enable_oprofile_monitor

#############################################################################
# (ROOT only) Debugger Mode :
# The following allow us attach gdb to daemon 
#echo "continue" > /tmp/ca_debug
#$SUDO $OPROFILED $@
#xterm -e "gdb $OPROFILED -p `cat /var/lib/oprofile/lock` -x /tmp/ca_debug" &

#############################################################################
# (SECURITY RISK) Force PATH Mode :
# NOTE: Oprofile-0.9.4 and later, we need to specify PATH to the daemon since
#       it will invoke the opjitconv tool. sudo overwrites the PATH variable
#       which will prevent daemon to locate opjitconv if not in /usr/bin/.
#	Also need to modify group.pl		
#echo "#!/bin/bash" > $OPROFILED_CMD 
#echo "PATH=$PATH ; $OPROFILED $@; rm -f $OPROFILED_CMD" >> $OPROFILED_CMD 
#chmod +x $OPROFILED_CMD 
#$SUDO $OPROFILED_CMD
